/***************************************************************************
                          errordlg.h  -  description
                             -------------------
    copyright            : (C) 2003 by Pierre Barbier de Reuille
    email                : harbort@nerim.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _ERRORDLG_HH_
#define _ERRORDLG_HH_

#include "errorbasedlg.h"

class QString;

class ErrorDlg : public ErrorBaseDlg
{
  Q_OBJECT

public:
  ErrorDlg(const QString& title, const QString& l1, const QString& l2 = QString::null,
	   const QString& l3 = QString::null, QWidget* parent = 0, const char *name = 0, WFlags fl = 0);
};

class ErrorInexistingRef : public ErrorDlg
{
public:
  ErrorInexistingRef(QString ref, QWidget* parent = 0, const char *name = 0, WFlags fl = 0);
};

class ErrorNameConflict : public ErrorDlg
{
public:
  ErrorNameConflict(QString conflict, QWidget* parent = 0, const char *name = 0, WFlags fl = 0);
};

class ErrorStillRef : public ErrorDlg
{
public:
  ErrorStillRef(QString ref, QWidget* parent = 0, const char *name = 0, WFlags fl = 0);
};

class ErrorSetZone : public ErrorDlg
{
public:
  ErrorSetZone(QWidget* parent = 0, const char *name = 0, WFlags fl = 0);
};

class ErrorZoneSet : public ErrorDlg
{
public:
  ErrorZoneSet(QWidget* parent = 0, const char *name = 0, WFlags fl = 0);
};

class ErrorXmlSyntax : public ErrorDlg
{
public:
  ErrorXmlSyntax(QWidget* parent = 0, const char *name = 0, WFlags fl = 0);
};

class ErrorBadData : public ErrorDlg
{
public:
  ErrorBadData(QWidget* parent = 0, const char *name = 0, WFlags fl = 0);
};
#endif
