/***************************************************************************
                          functions.h  -  description
                             -------------------
    copyright            : (C) 2003 by Pierre Barbier de Reuille
    email                : harbort@nerim.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _FUNCTIONS_HH_
#define _FUNCTIONS_HH_

#include <functional>
#include <string.h>

using namespace std;

template<class T>
struct PtrLess
{
  bool operator()(const T& o1, const T& o2)
    {
      return *o1 < *o2;
    }
};

namespace std
{
  template<>
  struct equal_to<const char*>
    : binary_function<const char*, const char*, bool>
  {
    bool operator()( const char* s1, const char* s2 ) const
      {
        return strcmp( s1, s2 ) == 0;
      }
  };
}
//#include "functions.tcc"

#endif
