/***************************************************************************
                          loadspace.h  -  description
                             -------------------
    copyright            : (C) 2003 by Pierre Barbier de Reuille
    email                : harbort@nerim.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _LOADSPACE_HH_
#define _LOADSPACE_HH_

#include "spacemap.h"
#include "spaceobject.h"
#include "spacezones.h"
#include "spacedesc.h"
#include "progwnd.h"
#include "objectref.h"

#include <qstring.h>

class QWidget;

class LoadSpace
{
public:
  LoadSpace(const QString& filename, QWidget* parent, ReferenceCenter* rc, SpaceMap& map, SpaceZones& zones, SpaceDescription& desc, ObjectRef& oref, ProgWnd& prog);
  bool operator()();
protected:
  void createLoadData();
  void loadZones(QDomElement& root);
  void loadMap(QDomElement& root);
  void loadGlobal(QDomElement& root);
  void loadMarine( QDomElement& root );
  void loadGenestealer( QDomElement& root );

  const QString& filename;
  QWidget *parent;
  ReferenceCenter* refCenter;
  SpaceMap& map;
  SpaceZones& zones;
  SpaceDescription& desc;
  ProgWnd& prog;
  ObjectRef& objRef;
};

#endif
