/***************************************************************************
                          objectref.h  -  description
                             -------------------
    copyright            : (C) 2003 by Pierre Barbier de Reuille
    email                : harbort@nerim.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef OBJECTREF_HH
#define OBJECTREF_HH

#include <set>
#include <vector>
#include "spaceref.h"

class SpaceObject;
class ProgElement;

class ObjectRef : public Referencer
{
public:
  enum TYPE_OBJECT
  {
    PROG,
    MAP
  } ;
  struct Object
  {
    TYPE_OBJECT type;
    union
    {
      ProgElement* prog;
      SpaceObject *map;
    };
  };
  typedef std::map<Referencer::reference_id, Object> ref_type;
  ObjectRef( ReferenceCenter* rc )
    : Referencer( rc ) {}
  Referencer::reference_id refAsObject( const QString& name, SpaceObject* obj );
  Referencer::reference_id refAsObject( const QString& name, ProgElement* obj );
  void bindObject( Referencer::reference_id ref );
  virtual void eraseReference( Referencer::reference_id ref );
  std::vector<Referencer::reference_id> objRefs() const;
  void clear();

protected:
  ref_type objects;
};

#endif // OBJECTREF_HH

