/***************************************************************************
                          progeditor.cpp  -  description
                             -------------------
    copyright            : (C) 2003 by Pierre Barbier de Reuille
    email                : harbort@nerim.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef _WIN32
#pragma warning (disable : 4786)
#endif

#include "progeditor.h"

#include "spacemap.h"
#include "spacezones.h"
#include "spaceref.h"
#include "progwnd.h"

#include <qscrollview.h>


ProgEditor::ProgEditor(QWidget * parent, const char * name, WFlags f)
  : QMainWindow(parent, name, f)
  , smap( NULL )
  , zones( NULL )
  , refCenter( NULL )
  , tree( NULL )
  , objRef( NULL )
{
  //view = new QScrollView(this, "progview");
  tree = new ProgWnd(this, "progwnd");
  //view->addChild(tree);
  tree->show();
  //setCentralWidget(view);
  setCentralWidget(tree);
  tree->show();
  setCaption("Spacehulk program editor");
}

ProgEditor::~ProgEditor()
{
}

void ProgEditor::setRef(SpaceMap* m, SpaceZones* z, ReferenceCenter *rc, ObjectRef* oref)
{
  smap = m;
  zones = z;
  refCenter = rc;
  objRef = oref;
  tree->setRef(m,z,rc,oref);
}

