/***************************************************************************
                          progtree.h  -  description
                             -------------------
    copyright            : (C) 2003 by Pierre Barbier de Reuille
    email                : harbort@nerim.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _PROGTREE_HH_
#define _PROGTREE_HH_

#include "rcobject.h"
#include "config.h"

#include <map>

#include <list>
#include "progelement.h"

#include <qwidget.h>
#include <qsize.h>

using namespace std;

class ProgWnd;

#include "progwnd.h"

class ProgTree : public ProgElement
{
public:
  enum ChildType
  {
    TEST,
    ACTION,
    VALUE,
    OBJECT_PLACE,
    OBJECT_FIND,
    OBJECT_SQUAD
  };
  ProgTree(QListView* parent, ProgRef* pref, QString index, const QString& name);
  ~ProgTree();
  virtual ProgElement* getCopy(ProgElement* , QString ) const { return NULL; }

protected:
  virtual bool validItem() { return true; }
  virtual bool isSameClass(ProgElement* element) const;
  static QPixmap* bitmap;
};

class ProgTreeGlobalInit : public ProgTree
{
public:
  ProgTreeGlobalInit(QListView* parent, ProgRef* pref, QString index );
  virtual QDomElement getXmlElement( QDomDocument& doc );
  virtual void setFromXml( QDomElement& xml );
};

class ProgTreeDraw : public ProgTree
{
public:
  ProgTreeDraw(QListView* parent, ProgRef* pref, QString index );
  virtual QDomElement getXmlElement( QDomDocument& doc );
  virtual void setFromXml( QDomElement& xml );
};

class ProgTreeMarineBegin : public ProgTree
{
public:
  ProgTreeMarineBegin(QListView* parent, ProgRef* pref, QString index );
  virtual QDomElement getXmlElement( QDomDocument& doc );
  virtual void setFromXml( QDomElement& xml );
};

class ProgTreeMarineInit : public ProgTree
{
public:
  ProgTreeMarineInit(QListView* parent, ProgRef* pref, QString index );
  virtual QDomElement getXmlElement( QDomDocument& doc );
  virtual void setFromXml( QDomElement& xml );
};

class ProgTreeMarineWin : public ProgTree
{
public:
  ProgTreeMarineWin(QListView* parent, ProgRef* pref, QString index );
  virtual QDomElement getXmlElement( QDomDocument& doc );
  virtual void setFromXml( QDomElement& xml );
};

class ProgTreeGenestealerBegin : public ProgTree
{
public:
  ProgTreeGenestealerBegin(QListView* parent, ProgRef* pref, QString index );
  virtual QDomElement getXmlElement( QDomDocument& doc );
  virtual void setFromXml( QDomElement& xml );
};

class ProgTreeGenestealerInit : public ProgTree
{
public:
  ProgTreeGenestealerInit(QListView* parent, ProgRef* pref, QString index );
  virtual QDomElement getXmlElement( QDomDocument& doc );
  virtual void setFromXml( QDomElement& xml );
};

class ProgTreeGenestealerWin : public ProgTree
{
public:
  ProgTreeGenestealerWin(QListView* parent, ProgRef* pref, QString index );
  virtual QDomElement getXmlElement( QDomDocument& doc );
  virtual void setFromXml( QDomElement& xml );
};

#endif

