/***************************************************************************
                          progwnd.h  -  description
                             -------------------
    copyright            : (C) 2003 by Pierre Barbier de Reuille
    email                : harbort@nerim.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _PROGWND_HH_
#define _PROGWND_HH_

#include "config.h"
#include "rcobject.h"

#include <map>
#include <vector>

#include <qwidget.h>
#include <qpixmap.h>
#include <qsize.h>
#include <qstring.h>
#include <qvbox.h>

using namespace std;

class QVBox;
class QListViewItem;

class ProgWnd;
class ProgMenu;
class ProgElement;

//class QScrollView;
class QListView;
class ProgRef;
class ReferenceCenter;
class SpaceMap;
class SpaceZones;
class QDomDocument;
class QDomElement;
class ProgTree;
class ObjectRef;

class ProgWnd : public QVBox
{
  Q_OBJECT

public:
  ProgWnd( QWidget * parent=0, const char * name=0, WFlags f=0 );
  ~ProgWnd();

  void setRef(SpaceMap* m, SpaceZones* z, ReferenceCenter *rc, ObjectRef* oref);

  QDomElement getXmlForGlobal( QDomDocument& doc ) const;
  QDomElement getXmlForDraw( QDomDocument& doc ) const;
  QDomElement getXmlForMarineInit( QDomDocument& doc ) const;
  QDomElement getXmlForMarineBegin( QDomDocument& doc ) const;
  QDomElement getXmlForMarineWin( QDomDocument& doc ) const;
  QDomElement getXmlForGenestealerInit( QDomDocument& doc ) const;
  QDomElement getXmlForGenestealerBegin( QDomDocument& doc ) const;
  QDomElement getXmlForGenestealerWin( QDomDocument& doc ) const;

  void setGlobalFromXml( QDomElement& xml );
  void setDrawFromXml( QDomElement& xml );
  void setMarineInitFromXml( QDomElement& xml );
  void setMarineBeginFromXml( QDomElement& xml );
  void setMarineWinFromXml( QDomElement& xml );
  void setGenestealerInitFromXml( QDomElement& xml );
  void setGenestealerBeginFromXml( QDomElement& xml );
  void setGenestealerWinFromXml( QDomElement& xml );

public slots:
  void changeItem( QListViewItem *, const QPoint &, int );
  void changeItem( int );
  void configItem( QListViewItem* );

protected:
  void createTrees();
  QListView* view;
  ProgElement *current;
  ProgMenu *menu;
  ProgRef *ref;
  ReferenceCenter *refCenter;
  SpaceMap *smap;
  SpaceZones *zones;
  ProgTree* trees[ 8 ];
  ObjectRef* objRef;

};

#endif

