/***************************************************************************
                          savespace.h  -  description
                             -------------------
    copyright            : (C) 2003 by Pierre Barbier de Reuille
    email                : harbort@nerim.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _SAVESPACE_HH_
#define _SAVESPACE_HH_

#include "spacemap.h"
#include "spaceobject.h"
#include "spacezones.h"
#include "spacedesc.h"
#include "progwnd.h"

#include <qstring.h>

using namespace std;

class SaveSpace
{
public:
  SaveSpace(const QString& filename, const SpaceMap& smap, SpaceZones& zones, const SpaceDescription& desc, const ProgWnd& prog);
  bool operator()();
protected:
  void saveZones(QDomElement& root, QDomDocument& doc);
  void saveMap(QDomElement& root, QDomDocument& doc);
  void saveGlobal(QDomElement& root, QDomDocument& doc);
  void saveOther(QDomElement& root, QDomDocument& doc); // Temporary method to write a valid file
  void saveProg( QDomElement& root, QDomDocument& doc );

  const QString& filename;
  const SpaceMap& smap;
  SpaceZones& zones;
  const SpaceDescription& desc;
  const ProgWnd& prog;
};

#endif
