/***************************************************************************
                          spacedesc.h  -  description
                             -------------------
    copyright            : (C) 2003 by Pierre Barbier de Reuille
    email                : harbort@nerim.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _SPACEDESC_HH_
#define _SPACEDESC_HH_

#include <qdom.h>
#include <qstring.h>

#include "spaceref.h"

class SpaceZones;
class QWidget;

class SpaceDescription
{
public:
  SpaceDescription(QWidget* parent, SpaceZones *zones, ReferenceCenter* rc);
  void edit();
  void setFromXml(QDomElement& root);
  void setFromFirstXml(QDomElement& root);
  void setFromPriorXml(QDomElement& root);
  void clear();
  QDomElement getXmlDescription(QDomDocument& doc) const;
  QDomElement getXmlForFirst(QDomDocument& doc) const;
  QDomElement getXmlForPrior(QDomDocument& doc) const;
protected:
  QWidget *parent;
  SpaceZones* zones;
  ReferenceCenter *refCenter;

  QString title;
  QString author;
  QString narration;
  QString objectives;
  QString forces;
  QString conditions;
  Referencer::reference_id objectiveZone;
  QString win_prior;
  QString first_player;
};

#endif
